'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _immutable = require('immutable');

var _immutable2 = _interopRequireDefault(_immutable);

var _localforage = require('localforage');

var _localforage2 = _interopRequireDefault(_localforage);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (key) {
	var config = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

	_localforage2.default.config(config);

	return {
		load: function load() {
			return _localforage2.default.getItem(key);
		},
		save: function save(state) {
			var stateProps = Object.getOwnPropertyNames(state);
			var newState = {};
			stateProps.forEach(function (stateProp) {
				if (_immutable2.default.Iterable.isIterable(state[stateProp])) {
					newState[stateProp] = state[stateProp].toJS();
				} else {
					newState[stateProp] = state[stateProp];
				}
			});
			return _localforage2.default.setItem(key, newState);
		}
	};
};